//Galaxia -- Meta Knight's sword. By takato14.

/////////////
//--SOUND--//
/////////////

datablock audioProfile(MetaSwingSound1)
{
	filename = "./GalaxiaSwing1.wav";
	description = audioClose3d;
	preload = true;
};

datablock audioProfile(MetaSwingSound2)
{
	filename = "./GalaxiaSwing2.wav";
	description = audioClose3d;
	preload = true;
};

//datablock audioProfile(MetaHitSound)
//{
	//filename = "./GalaxiaHit.wav";
	//description = audioClose3d;
	//preload = true;
//};

/////////////////
//--EXPLOSION--//
/////////////////

datablock explosionData(MetaExplosion : SwordExplosion)
{
	audioProfile = metaHitSound;
	uiName = "Galaxia";
};

datablock explosionData(MetaPowerExplosion : rocketExplosion)
{
	soundProfile = swordHitSound;
	uiName = "Galaxia Smash Attach";
	lightStartColor = swordExplosion.lightStartColor;
	lightEndColor = swordExplosion.lightEndColor;
	lightStartRadius = 10;
	lightEndRadius = 0;
	particleDensity = 40;
	particleRadius = 2.3;

	
	particleEmitter = swordExplosionEmitter;
	impulseRadius = 2;
	damageRadius = 10;
	radiusDamage = 0;

};


//////////////////
//--PROJECTILE--//
//////////////////

AddDamageType("Meta",   '<bitmap:add-ons/Weapon_TSP/Galaxia/CI_Galaxia> %1',    '%2 <bitmap:add-ons/Weapon_TSP/Galaxia/CI_Galaxia> %1',0.75,1);
datablock projectileData(MetaProjectile : swordProjectile)
{
	directDamageType = $damageType::Meta;
	radiusDamageType = $damageType::Meta;
	directDamage = 10;
	lifetime = 128;
	explosion = MetaExplosion;
	uiName = "Galaxia";
};

datablock projectileData(MetaPowerProjectile : MetaProjectile)
{
	directDamage = 60;
	uiName = "Galaxia Smash Attack";
	explosion = metaPowerExplosion;
	impactimpulse = 1000;
	verticalimpulse = 1000;
};

////////////
//--ITEM--//
////////////

datablock itemData(MetaItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./GalaxiaNH.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Galaxia";
	iconName = "./icon_Galaxia";
	doColorShift = false;
	colorShiftColor = "0.1 0.196 0.1 1.000";

	 // Dynamic properties defined by the scripts
	image = MetaImage;
	canDrop = true;

};

////////////////////
//--WEAPON IMAGE--//
////////////////////

datablock shapeBaseImageData(MetaImage)
{
   shapeFile = "./Galaxia.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = MetaItem;
   ammo = " ";
   projectile = MetaProjectile;
   projectileType = Projectile;
   melee = true;
   doRetraction = false;
  
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

 	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = "";
	stateSequence[0]			 = "idle";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "prepswing";
	stateAllowImageChange[1]         = true;
	stateSequence[1]			 = "idle";
	

	stateName[2]			= "prepSwing";
	stateScript[2]                  = "onprepSwing";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.2;
	stateTransitionOnTimeout[2]     = "Swing1";
	stateSequence[2]			= "prepareSwing";

	stateName[3]                    = "swing1";
	stateTransitionOnTimeout[3]     = "CheckFire1";
	stateTimeoutValue[3]            = 0.07;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	stateSequence[3]			= "Swing1";
	stateSound[3]				= MetaSwingSound1;

	stateName[4]			= "CheckFire1";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Swing2";
	
	stateName[5]                    = "swing2";
	stateTransitionOnTimeout[5]     = "CheckFire2";
	stateTimeoutValue[5]            = 0.07;
	stateFire[5]                    = true;
	stateAllowImageChange[5]        = false;
	stateScript[5]                  = "onFire";
	stateWaitForTimeout[5]		= true;
	stateSequence[5]			= "Swing2";
	stateSound[5]				= MetaSwingSound1;

	stateName[6]			= "CheckFire2";
	stateTransitionOnTriggerUp[6]	= "StopFire";
	stateTransitionOnTriggerDown[6]	= "Swing3";

	stateName[7]                    = "swing3";
	stateTransitionOnTimeout[7]     = "CheckFire3";
	stateTimeoutValue[7]            = 0.07;
	stateFire[7]                    = true;
	stateAllowImageChange[7]        = false;
	stateScript[7]                  = "onFire";
	stateWaitForTimeout[7]		= true;
	stateSequence[7]			= "Swing3";
	stateSound[7]				= MetaSwingSound1;

	stateName[8]			= "CheckFire3";
	stateTransitionOnTriggerUp[8]	= "StopFire";
	stateTransitionOnTriggerDown[8]	= "Swing4";

	stateName[9]                    = "swing4";
	stateTransitionOnTimeout[9]     = "CheckFire4";
	stateTimeoutValue[9]            = 0.07;
	stateFire[9]                    = true;
	stateAllowImageChange[9]        = false;
	stateScript[9]                  = "onFire";
	stateWaitForTimeout[9]		= true;
	stateSequence[9]			= "Swing4";
	stateSound[9]				= MetaSwingSound1;

	stateName[10]			= "CheckFire4";
	stateTransitionOnTriggerUp[10]	= "StopFire";
	stateTransitionOnTriggerDown[10]	= "Swing1";

	stateName[11]                    = "StopFire";
	stateTransitionOnTimeout[11]     = "Ready";
	stateTimeoutValue[11]            = 0.2;
	stateAllowImageChange[11]        = false;
	stateWaitForTimeout[11]		= true;
	stateSequence[11]                = "StopFire";
	stateScript[11]                  = "onStopFire";
};

datablock shapeBaseImageData(MetaPowerImage)
{
	 shapeFile = "./Galaxia.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = MetaItem;
   ammo = " ";
   projectileType = Projectile;
   melee = true;
   doRetraction = false;
  
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

  	projectile = metaPowerProjectile;

 	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.0;
	stateTransitionOnTimeout[0]      = "PrepSwing";
	stateSound[0]                    = "";
	stateSequence[0]			 = "idle";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "prepswing";
	stateAllowImageChange[1]         = true;
	stateSequence[1]			 = "idle";
	

	stateName[2]			= "prepSwing";
	stateScript[2]                  = "onprepSwing";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.8;
	stateEmitter[2]				= ShardGunTrailEmitter;
	stateEmitterNode[2]			= "tipNode";
	stateTransitionOnTimeout[2]     = "PowerSwing";
	stateSequence[2]			= "PowerSwingPrep";

	stateName[3]                    = "PowerSwing";
	stateTransitionOnTimeout[3]     = "wait";
	stateTimeoutValue[3]            = 0.08;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	stateSequence[3]			= "PowerSwing";
	stateSound[3]				= MetaSwingSound2;

	stateName[4]			= "done";
	stateScript[4]			= "onDone";
	stateTimeoutValue[4]		= 0.9;
	
	stateName[5]			= "wait";
	stateTimeoutValue[5]		= 0.4;
	stateTransitionOnTimeout[5]	= "done";
	
};


/////////////////////////
//--SPECIAL FUNCTIONS--//
/////////////////////////

function MetaImage::onMount(%this, %obj, %slot)
{
	%obj.hideNode(rhand);
}

function MetaImage::onUnMount(%this, %obj, %slot)
{
	%obj.unHideNode(rhand);
}

function MetaPowerImage::onMount(%this, %obj, %slot)
{
	%obj.hideNode(rhand);
}

function MetaPowerImage::onUnMount(%this, %obj, %slot)
{
	%obj.unHideNode(rhand);
}

package  ConsoleErrorStopper
{
	function Armor::onTrigger(%this,%obj,%slot,%val)
   	{
     	 Parent::onTrigger(%this,%obj,%slot,%val);
     	 if(%slot == 4 && %val)
     	 {
     	    if(%obj.getMountedImage(0) == MetaImage.getID())
     	    {
     	       %obj.updateArm(MetaPowerImage);
     	       %obj.mountImage(MetaPowerImage,0);
     	    }
     	 }
   	}
};
activatePackage(ConsoleErrorStopper);

function MetaPowerImage::onDone(%this,%obj,%slot)
{
	%obj.MountImage(Metaimage,0);
}

function MetaImage::onFire(%this, %obj, %slot)
{
	parent::onFire(%this, %obj, %slot);
	%obj.playthread(0, plant);
}	




