//The Hylian Sheild was not left 'active' in the pack because Space Guy didn't want me to use his code. I repsect that. However, I wasnt going to let my first textured model go to waste, so I left it in the pack and hid it. This shield automatically mounts when you use the Master Sword, and you can select it in the UI list to use it with other weapons as well. (The only way to unequip the sheild is to switch to and from the master sword(or an akimbo weapon), so be warned)

//////////
// item //
//////////
datablock ItemData(HylianItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Hylian.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Hylian Shield";

	iconName = "./hylian";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = HylianFrontImage;
	canDrop = true;
};

datablock ShapeBaseImageData(HylianFrontImage)
{
   // Basic Item properties
   shapeFile = "./Hylian.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 1;
   offset = "0.5 0.1 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 90" );
   scale = "1 1 1";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this Weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = " ";
   ammo = " ";
   projectile = "";
   projectileType = "Projectile";

   casing = "";
   //shellExitDir        = "1.0 -1.3 1.0";
   //shellExitOffset     = "0 0 0";
   //shellExitVariance   = 15.0;   
   //shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.196 0.196 0.196 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
   stateName[0]                     = "Activate";
   stateTimeoutValue[0]             = 0.15;
   stateTransitionOnTimeout[0]       = "Ready";
   stateSound[0]               = WeaponSwitchSound;

   stateName[1]                     = "Ready";
   stateAllowImageChange[1]         = true;
   stateSequence[1]   = "Ready";

};




package Shield
{
   
   function MasterImage::onMount(%this,%obj,%slot)
   {
      Parent::onMount(%this,%obj,%slot);
      %obj.mountImage(HylianFrontImage,1);
      %obj.playthread(1, armReadyLeft);
   }
   
   function MasterImage::onPreFire(%this,%obj,%slot)
   {
      Parent::onPreFire(%this,%obj,%slot);
      %obj.playthread(1, armReadyRight);
   }
   
   function MasterImage::onUnMount(%this,%obj,%slot)
   {
      Parent::onUnMount(%this,%obj,%slot);
      %obj.unMountImage(1);
      fixArmReady(%obj);
   }
   
   function MasterImage::onStopFire(%this, %obj, %slot)
   {   
      %obj.playthread(2, root);
      %obj.playthread(1, armReadyLeft);
   }
   
   function ProjectileData::damage(%this,%obj,%col,%fade,%pos,%normal) 
   {
      %shielded = 0;
      if(%col.getType() & $TypeMasks::PlayerObjectType)
      {
         %image0 = %col.getMountedImage(0);
         %image1 = %col.getMountedImage(1);
         %image2 = %col.getMountedImage(2);
         %state0 = %col.getImageState(0);
         
         %scale = getWord(%col.getScale(),2);
         
         %fvec = %col.getForwardVector();
         %fX = getWord(%fvec,0);
         %fY = getWord(%fvec,1);
         
         %evec = %col.getEyeVector();
         %eX = getWord(%evec,0);
         %eY = getWord(%evec,1);
         %eZ = getWord(%evec,2);
         
         %eXY = mSqrt(%eX*%eX+%eY*%eY);
         
         %aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
         
         if(%image1 == HylianFrontImage.getID() && %state0 $= "Ready")
         {
            if(%eZ > 0.75)
               %shielded = (getword(%pos, 2) > getword(%col.getWorldBoxCenter(),2) - 3.3*%scale);
            else if(%ez < -0.75)
               %shielded = (getword(%pos, 2) < getword(%col.getWorldBoxCenter(),2) - 4.4*%scale);
            else if(%col.isCrouched())
               %shielded = (vectorDot(vectorNormalize(%obj.getVelocity()),%aimVec) < 0);
            else
               %shielded = (getword(%pos, 2) < getword(%col.getWorldBoxCenter(),2) - 3.3*%scale) && (getword(%pos, 2) > getword(%col.getWorldBoxCenter(),2) - 4.4*%scale) && (vectorDot(vectorNormalize(%obj.getVelocity()),%aimVec) < 0);
            if(%this.getID() == MasterProjectile.getID())
               %shielded = 0;
            
            %damageScale = 0;
            if(%shielded)
               %col.playThread(3, leftrecoil);
            %reflect = $Shield::MasterReflects;
            %reflectVector = %col.getMuzzleVector(1);
            %reflectPoint = %col.getMuzzlePoint(1);
            %impulseScale = 0.5;
         }
      }
      
      if(getSimTime() - %obj.reflectTime < 500) %reflect = 0;
      
      if(%shielded)
      {
         //cancel radius damage on %obj
         %obj.damageCancel[%col] = 1;
         %obj.impulseScale[%col] = %impulseScale;
         serverPlay3d(wrenchMissSound,%pos);
         
         if(%reflect)
         {
            %scaleFactor = getWord(%obj.getScale(), 2);
            %pos = %reflectPoint;
            %vec = vectorScale(%reflectVector,vectorLen(%obj.getVelocity()));
            %vel = vectorAdd(%vec,vectorScale(%col.getVelocity(),%obj.dataBlock.velInheritFactor));
            %p = new Projectile()
            {
               dataBlock = %obj.dataBlock;
               initialPosition = %pos;
               initialVelocity = %vel;
               sourceObject = %obj;
               client = %col.client;
               sourceSlot = 0;
               originPoint = %pos;
               reflectTime = getSimTime();
            };
            MissionCleanup.add(%p);
            %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
         }
         
         %obj.schedule(10,delete);
         
         //Special effect weapons like the Horse Ray will still affect you from the back
         if(%damageScale > 0)
         {
            %this.directDamage *= %damageScale;
            %ret = Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
            %this.directDamage /= %damageScale;
         }
         
         return %ret;
      }
      else
      {
         return Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
      }
   }
   
   function ProjectileData::radiusDamage(%this, %obj, %col, %distanceFactor, %pos, %damageAmt)
   {
      if(%obj.damageCancel[%col])
         return;
      
      return Parent::radiusDamage(%this, %obj, %col, %distanceFactor, %pos, %damageAmt);
   }
   
   function ProjectileData::radiusImpulse(%this, %obj, %col, %a, %pos, %b, %c)
   {
      if(%obj.damageCancel[%col])
      {
         %b = %b * %obj.impulseScale[%col];
      }
      
      return Parent::radiusImpulse(%this, %obj, %col, %a, %pos, %b, %c);
   }
   
   function ProjectileData::impactImpulse(%this, %obj, %col, %a)
   {
      if(%obj.damageCancel[%col])
      {
         %this.impactImpulse *= %obj.impulseScale[%col];
         %val = Parent::impactImpulse(%this, %obj, %col, %a);
         %this.impactImpulse /= %obj.impulseScale[%col];
         return %val;
      }
      
      return Parent::impactImpulse(%this, %obj, %col, %a);
   }
   
   function ShapeBase::damage(%this, %sourceObject, %pos, %directDamage, %damageType)
   {
      %image0 = %this.getMountedImage(0);
      %image1 = %this.getMountedImage(1);
      %image2 = %this.getMountedImage(2);
      %state0 = %this.getImageState(0);
      
      %fvec = %this.getForwardVector();
      %fX = getWord(%fvec,0);
      %fY = getWord(%fvec,1);
      
      %evec = %this.getEyeVector();
      %eX = getWord(%evec,0);
      %eY = getWord(%evec,1);
      %eZ = getWord(%evec,2);
      
      %eXY = mSqrt(%eX*%eX+%eY*%eY);
      
      %aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
      
      if(%damageType == $DamageType::Fall || %damageType == $DamageType::Impact)
      {
         %quit = 1;
         
         if(%damageType == $DamageType::Fall)
            %attackvec = "0 0 -1";
         else
            %attackvec = vectorNormalize(vectorSub(%this.getHackPosition(),%pos));
         
         %fvec = %this.getForwardVector();
         %fX = getWord(%fvec,0);
         %fY = getWord(%fvec,1);
         
         %evec = %this.getEyeVector();
         %eX = getWord(%evec,0);
         %eY = getWord(%evec,1);
         %eZ = getWord(%evec,2);
         
         %eXY = mSqrt(%eX*%eX+%eY*%eY);
         
         %aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
         if(%image0 == shieldRiotImage.getID() && %state0 $= "Ready")
            %shielded = (vectorDot(%attackVec,%aimVec) > 0);
         
         if(%shielded && $Shield::RiotCancelFalling)
         {
            %this.spawnExplosion(hammerProjectile,getWord(%this.getScale(),2)*2);
            %directDamage = %directDamage/8;
         }
      }
      else if(!%quit && (%this.getType() & $TypeMasks::PlayerObjectType) && !%sourceObject.damageCancel[%obj])
      {
         %scale = getWord(%this.getScale(),2);
         
         %attackvec = vectorNormalize(vectorSub(%this.getHackPosition(),%pos));
         
         if(%image0 == shieldRiotImage.getID() && %state0 $= "Ready")
         {
            if(%eZ > 0.75)
               %shielded = (getword(%pos, 2) > getword(%this.getWorldBoxCenter(),2) - 3.3*%scale);
            else if(%ez < -0.75)
               %shielded = (getword(%pos, 2) < getword(%this.getWorldBoxCenter(),2) - 4.4*%scale);
            else
               %shielded = (vectorDot(%attackvec,%aimVec) < 0);
            
            %damageScale = 0;
            if(vectorDist(%pos,"0 0 0") < 0.1) %shielded = 0;
            if(vectorDist(%pos,%this.getPosition()) < 0.1) %shielded = 0;
            if(%directDamage > 5000) %shielded = 0;
            
            if(%shielded)
               %this.spawnExplosion(hammerProjectile,getWord(%this.getScale(),2));
         }
         else if(%image1 == HylianFrontImage.getID() && %state0 $= "Ready")
         {
            if(%eZ > 0.75)
               %shielded = (getword(%pos, 2) > getword(%this.getWorldBoxCenter(),2) - 3.3*%scale);
            else if(%ez < -0.75)
               %shielded = (getword(%pos, 2) < getword(%this.getWorldBoxCenter(),2) - 4.4*%scale);
            else if(%this.isCrouched())
               %shielded = (vectorDot(vectorNormalize(%attackvec,%aimVec) < 0));
            else
               %shielded = (getword(%pos, 2) < getword(%this.getWorldBoxCenter(),2) - 3.3*%scale) && (getword(%pos, 2) > getword(%this.getWorldBoxCenter(),2) - 4.4*%scale) && (vectorDot(%attackvec,%aimVec) < 0);
            
            if(%damageType == $DamageType::Impact || %damageType == $DamageType::Fall)
               %shielded = 0;
            
            %damageScale = 0;
            if(vectorDist(%pos,"0 0 0") < 0.1) %shielded = 0;
            if(vectorDist(%pos,%this.getPosition()) < 0.1) %shielded = 0;
            if(%directDamage > 5000) %shielded = 0;
            
            if(%shielded)
               %this.playThread(3, leftrecoil);
         }
         else if(%image2 == shieldRiotBackImage.getID())
         {
            if(%eZ > 0.75)
               %shielded = (getword(%pos, 2) < getword(%this.getWorldBoxCenter(),2) - 4.4*%scale);
            else if(%ez < -0.75)
               %shielded = (getword(%pos, 2) > getword(%this.getWorldBoxCenter(),2) - 3.3*%scale);
            else
               %shielded = (vectorDot(%attackvec,%aimVec) > 0);
            
            %damageScale = 0.5;
            if(vectorDist(%pos,"0 0 0") < 0.1) %shielded = 0;
            if(vectorDist(%pos,%this.getPosition()) < 0.1) %shielded = 0;
            if(%directDamage > 5000) %shielded = 0;
            
            if(%shielded)
               %this.spawnExplosion(hammerProjectile,getWord(%this.getScale(),2));
         }
         
         if(%shielded)
            %directDamage = %directDamage * %damageScale;
      }
      return Parent::damage(%this, %sourceObject, %pos, %directDamage, %damageType);
   }
   
   function Player::pickup(%this,%item)
   {
      %data = %item.dataBlock;
      %val = Parent::pickup(%this,%item);
      
      if(%data.getID() == RiotShieldItem.getID() && %val == 1 && !isObject(%this.ctfFlagSpawnBrick) && $Shield::RiotOnBack)
      {
         for(%i=2;%i<7;%i++){%this.hideNode($pack[%i]);}
         %this.mountImage(shieldRiotBackImage,2);
      }
      
      return %val;
   }
   
   function servercmdDropTool(%this,%slot)
   {
      if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot] == RiotShieldItem.getID())
      {
         parent::servercmdDropTool(%this,%slot);
         
         if(%this.player.getmountedimage(2) == shieldRiotBackImage.getID())
            %this.player.schedule(5,unmountimage,2);
         %this.applyBodyParts();
         %this.applyBodyColors();
         return;
      }
      parent::servercmdDropTool(%this,%slot);
   }
   
   function ctfFlagItem::onPickup(%this,%obj,%player,%amt)
   {
      %ret = Parent::onPickup(%this,%obj,%player,%amt);
      if(isObject(%player.ctfFlagSpawnBrick) && %player.getMountedImage(2) == shieldRiotBackImage.getID())
         %player.unmountImage(2);
      if(isObject(%player.client))
      {
         %player.client.applyBodyParts();
         %player.client.applyBodyColors();
      }
      
      return %ret;
   }
};activatepackage(Shield);


