//Master.cs

//Hidden feature: Wind Waker Master Sword

//exec("./Windwaker.cs");

AddDamageType("Master",   '<bitmap:add-ons/Weapon_TSP/Master Sword [TP]/CI_Master> %1',    '%2 <bitmap:add-ons/Weapon_TSP/Master Sword [TP]/CI_Master> %1',0.75,1);

datablock Projectiledata(Masterprojectile : raptorProjectile)
{
	lifetime = 75;
	directDamageType = $damageType::Master;
	radiusDamageType = $damageType::Master;
	directDamage = 40;
	
};

datablock DebrisData(TDGDebris)
{
   emitters = "ChidoriTrailEmitter";

	lifetime = 0.1;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0; 
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 0;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = false;

	gravModifier = 0;
};

datablock ExplosionData(TDGExplosion)
{
   //explosionShape = "";
   //explosionShape = "./explosionSphere1.dts";
	soundProfile = ChidoriHitSound;

   particleEmitter = ChidoriExplosionEmitter;
   particleDensity = 100;
   particleRadius = 1;

   emitter[0] = ChidoriSparkEmitter;
   emitter[1] = ChidoriTrailEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

  shakeCamera = true;
   camShakeFreq = "30.0 20.0 25.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 5.0;
   camShakeRadius = 2.0;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 3;
   lightStartColor = "0.0 0.6 0.6 0.9";
   lightEndColor = "0.0 0.1 1.0 1";

   debris = TDGDebris;
   debrisNum = 30;
   debrisNumVariance = 10;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 100;
   debrisVelocityVariance = 50;

   damageRadius = 1;
   radiusDamage = 1000;

   uiname = "";
};

datablock Projectiledata(MasterProjectileFull : ChidoriProjectile)
{
	lifetime = 75;
	explosion = TDGexplosion;
	directDamage = 80;
};




datablock ItemData(MasterItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Master.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Master Sword [TP]";



	iconName = "./Master";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = MasterImage;
	canDrop = true;
};

//////////
// item //
//////////

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MasterImage)
{
   // Basic Item properties
   shapeFile = "./Master.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = 0; //"0.7 1.2 -0.25";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MasterItem;
   ammo = " ";
   projectile = MasterProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = RaptorDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.2;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateTimeoutValue[4]			= 0.5;
	stateWaitForTimeout[4]		= true;

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.9;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function Masterimage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function MasterImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

//The charge-up function is incomplete, and currently breaks the weapon. Once it works, it will be put into the next version.

//A BIG thanks to Brain Smith [BL_ID: _____] for this part. This makes the sword fire a power beam when your health is full.
package Chargebeam
{

	function masterImage::onFire(%this, %obj, %slot) 
	{
		if(%obj.getDamageLevel() > 0) 
		{
			echo("The player has already been damaged.");
			%p = new Projectile(MasterProjectile) 
			{
				datablock = MasterProjectile; 
				initialVelocity = %velocity; 
				initialPosition = %obj.getMuzzlePoint(%slot); 
				sourceObject = %obj; 
				sourceSlot = %slot; 
				client = %obj.client; 
			}; 
		MissionCleanup.add(%p); 
		}
		else 
		{ 
			echo("The player's health is full.");
			%p = new Projectile(MasterProjectileFull) 
			{ 
				datablock = MasterProjectileFull; 
				initialVelocity = %velocity; 
				initialPosition = %obj.getMuzzlePoint(%slot); 
				sourceObject = %obj; 
				sourceSlot = %slot; 
				client = %obj.client; 
			}; 
			MissionCleanup.add(%p); 
		}
	} 
};


//activatePackage(ChargeBeam); //--It doesn't work yet :<

//Load the Hylian Sheild, if you were smart enough to find this.

//exec("./Hylian.cs");
