//Reshef -- By takato14.

/////////////
//--SOUND--//
/////////////

//////////////////
//--PROJECTILE--//
//////////////////

AddDamageType("Reshef",   '<bitmap:add-ons/Weapon_TSP/Reshef/CI_Reshef> %1',    '%2 <bitmap:add-ons/Weapon_TSP/Reshef/CI_Reshef> %1',0.75,1);
datablock projectileData(ReshefProjectile : swordProjectile)
{
	directDamageType = $damageType::Reshef;
	radiusDamageType = $damageType::Reshef;
	directDamage = 40;
	lifetime = 128;
	explosion = swordExplosion;
	uiName = "Reshef";
};

////////////
//--ITEM--//
////////////

datablock itemData(ReshefItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ReshefNH.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Reshef";
	iconName = "./icon_Reshef";
	doColorShift = false;
	colorShiftColor = "0.1 0.196 0.1 1.000";

	 // Dynamic properties defined by the scripts
	image = ReshefImage;
	canDrop = true;

};

////////////////////
//--WEAPON IMAGE--//
////////////////////

datablock shapeBaseImageData(ReshefImage)
{
   shapeFile = "./Reshef.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   correctMuzzleVector = false;
   className = "WeaponImage";
   item = ReshefItem;
   ammo = " ";
   projectile = ReshefProjectile;
   projectileType = Projectile;
   melee = true;
   doRetraction = false;
  
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

 	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = "";
	stateSequence[0]			 = "idle";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "swing1start";
	stateAllowImageChange[1]         = true;
	stateSequence[1]			 = "idle";
	
	stateName[2]			= "swing1start";
	stateScript[2]                  = "onprepSwing";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.2;
	stateTransitionOnTimeout[2]     = "Swing1end";
	stateSequence[2]			= "swing1start";

	stateName[3]                    = "swing1end";
	stateTransitionOnTimeout[3]     = "CheckFire1";
	stateTimeoutValue[3]            = 0.07;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	stateSequence[3]			= "swing1end";
	//stateSound[3]				= MetaSwingSound1;

	stateName[4]			= "CheckFire1";
	stateTransitionOnTriggerUp[4]	= "StopFire1";
	stateTransitionOnTriggerDown[4]	= "Swing2start";

	stateName[5]			= "swing2start";
	stateScript[5]                  = "onprepSwing";
	stateAllowImageChange[5]        = false;
	stateTimeoutValue[5]            = 0.2;
	stateTransitionOnTimeout[5]     = "Swing2end";
	stateSequence[5]			= "swing2start";

	stateName[6]                    = "swing2end";
	stateTransitionOnTimeout[6]     = "CheckFire2";
	stateTimeoutValue[6]            = 0.07;
	stateFire[6]                    = true;
	stateAllowImageChange[6]        = false;
	stateScript[6]                  = "onFire";
	stateWaitForTimeout[6]		= true;
	stateSequence[6]			= "Swing2end";
	//stateSound[6]				= MetaSwingSound1;

	stateName[8]			= "CheckFire2";
	stateTransitionOnTriggerUp[8]	= "StopFire2";
	stateTransitionOnTriggerDown[8]	= "Swing3start";

	stateName[9]			= "swing3start";
	stateScript[9]                  = "onprepSwing";
	stateAllowImageChange[9]        = false;
	stateTimeoutValue[9]            = 0.2;
	stateTransitionOnTimeout[9]     = "Swing3end";
	stateSequence[9]			= "swing3start";

	stateName[10]                    = "swing3end";
	stateTransitionOnTimeout[10]     = "stopFire3";
	stateTimeoutValue[10]            = 0.07;
	stateFire[10]                    = true;
	stateAllowImageChange[10]        = false;
	stateScript[10]                  = "onFire";
	stateWaitForTimeout[10]		= true;
	stateSequence[10]			= "Swing3end";
	//stateSound[10]				= MetaSwingSound1;

	stateName[11]                    = "StopFire1";
	stateTransitionOnTimeout[11]     = "Ready";
	stateTimeoutValue[11]            = 0.2;
	stateAllowImageChange[11]        = false;
	stateWaitForTimeout[11]		= true;
	stateSequence[11]                = "swing1return";
	stateScript[11]                  = "onStopFire";

	stateName[12]                    = "StopFire2";
	stateTransitionOnTimeout[12]     = "Ready";
	stateTimeoutValue[12]            = 0.2;
	stateAllowImageChange[12]        = false;
	stateWaitForTimeout[12]		= true;
	stateSequence[12]                = "swing2return";
	stateScript[12]                  = "onStopFire";

	stateName[7]                    = "StopFire3";
	stateTransitionOnTimeout[7]     = "Ready";
	stateTimeoutValue[7]            = 0.2;
	stateAllowImageChange[7]        = false;
	stateWaitForTimeout[7]		= true;
	stateSequence[7]                = "swing3return";
	stateScript[7]                  = "onStopFire";
};

/////////////////////////
//--SPECIAL FUNCTIONS--//
/////////////////////////

function ReshefImage::onMount(%this, %obj, %slot)
{
	%obj.hideNode(rhand);
}

function ReshefImage::onUnMount(%this, %obj, %slot)
{
	%obj.unHideNode(rhand);
}